<template>
  <div class="col-sm-6 col-md-4">
    <div class="card text-white bg-info mb-3">
      <div class="card-header">
        <h6>
          {{stock.name}}
          <small>(Price: {{stock.price}} | Quantity: {{stock.quantity}})</small>
        </h6>
      </div>
      <div class="card-body">
        <div class="control-section">
          <input
            :class="{danger: insufficientFunds}"
            type="number"
            class="form-control"
            v-model="quantity"
            placeholder="Quantity"
          />
          <button
            class="btn btn-warning"
            :disabled="insufficientFunds || quantity <=0 || !Number(quantity)"
            @click="sellStock"
          >{{ insufficientFunds ? 'Not enough' : 'Sell' }}</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
export default {
  props: ["stock"],
  data() {
    return {
      quantity: 0
    };
  },
  computed: {
    insufficientFunds() {
      return this.quantity > this.stock.quantity;
    }
  },
  methods: {
    ...mapActions({
      sellOrder: "sellStocks"
    }),
    sellStock() {
      const order = {
        stockId: this.stock.id,
        stockPrice: this.stock.price,
        quantity: this.quantity
      };
      this.sellOrder(order);
      this.quantity = 0;
    }
  }
};
</script>

<style scoped>
.danger {
  border: 1px solid red;
}
.control-section {
  display: flex;
  align-items: center;
  justify-content: space-between;
}
.control-section input {
  margin-right: 15px;
  max-width: 150px;
}
</style>